<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 6 $
 * $Author: PragmaMx $
 * $Date: 2015-07-08 09:07:06 +0200 (Mi, 08. Jul 2015) $
 */

/*

# Contest-KATEGORIENAME-??.html
RewriteRule ^Contest-category.*-([0-9]+)(-.*)?\.html$ mod.php?Contest&________________________cid-$1$2 [L]
RewriteRule ^Contest-title.*-([0-9]+)(-.*)?\.html$ mod.php?Contest&________________________pid-$1$2 [L]
RewriteRule ^Contest-picture.*-([0-9]+)(-.*)?\.html$ mod.php?Contest&________________________pa-contest_pic_show-pid-$1$2 [L]

*/

$hook = function($name, $parameter, &$replaces)
{
    if (!isset($parameter[$name])) {
        return;
    }
    global $prefix;

    $cid = array();
    $pid = array();
    $pic = array();
    $rules = array();
    $rules2 = array();

    foreach ($parameter[$name] as $key => $para) {
        switch (true) {
            case ((isset($para['pa']) && $para['pa'] == 'contest_pic_show') && (isset($para['pid']) && intval($para['pid']))):
                $pic[0][] = $para['pid'];
                $pic[$key] = $para;
                break;
            case (isset($para['cid']) && intval($para['cid']) && !(isset($para['pa']))):
                $cid[0][] = $para['cid'];
                $cid[$key] = $para;
                break;
            case (isset($para['pid']) && intval($para['pid']) && !(isset($para['pa']))):
                $pid[0][] = $para['pid'];
                $pid[$key] = $para;
                break;
            case (isset($para['pa']) && $para['pa'] == 'contest_rules'):
                $rules[0][] = $para['cid'];
                $rules[$key] = $para;
                break;
            case (isset($para['pa']) && $para['pa'] == 'contest_show_rules'):
                $rules2[0][] = $para['con'];
                $rules2[$key] = $para;
                break;
            case (isset($para['pa']) && $para['pa'] == 'statistics'):
                $new_url = $name . '-statistics.html';
                $replaces[$key] = $para['prefix'] . $new_url . $para['suffix'];
                break;
            case (isset($para['pa']) && $para['pa'] == 'mostpoints'):
                $new_url = $name . '-mostpoints.html';
                $replaces[$key] = $para['prefix'] . $new_url . $para['suffix'];
                break;
            case (isset($para['pa']) && $para['pa'] == 'mostviewed'):
                $new_url = $name . '-mostviewed.html';
                $replaces[$key] = $para['prefix'] . $new_url . $para['suffix'];
                break;
        }
    }

    /**
     * Downloads-KATEGORIENAME-cat63.html
     * RewriteRule ^(Downloads)-.*-cat([0-9]+)(-.*)\.html$ mod.php?$1&________________________cid-$2$3 [L]
     */
    if ($cid) {
        $inquery = implode(',', array_unique(array_shift($cid)));
        $qry = "SELECT catid, cattitle FROM {$prefix}_pmxContest_category WHERE catid in ($inquery)";
        $result = sql_query($qry);
        while (list($catid, $title) = sql_fetch_row($result)) {
            /**
             * den aus der DB ausgelesenen Titel als URL tauglich machen
             * - Umlaute werden umgeschrieben
             * - Sonderzeichen werden durch den angegebenen 2ten Parameter ersetzt
             * Einstellung:
             * der zweite Parameter der Funktion, als Sonderzeichenersatz
             */
            $titles[$catid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($cid as $key => $link) {
            /**
             * schreibt alle Parameter um in das normale pragmaMx mod_reweite Format,
             * also getrennt mit den Bindestrichen
             * Einstellung:
             * alle Parameter, die nicht benötigt werden, weil sie z.B. anderweitig
             * in der URL verwendet werden, als zusätzlichen Parameter der Funktion
             * übergeben
             */
            $new_url = pmxModrewrite::title_parameters($link, 'cid');
            /**
             * den neuen URL zusammensetzen
             * Einstellung:
             * nach belieben zusammensetzen und entspr. die .htaccess anpassen
             */
            // $title = $name . '-lid-' . $title . '-' . $lid . $end; // Original m-t
            $new_url = $name . '-category-' . $titles[$link['cid']] . '-' . $link['cid'] . $new_url;
            /**
             * die globalen Ersetzungsparameter mit den neuen Werten überschreiben
             * Einstellung: keine, muss exakt so bleiben!
             */
            $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
        }
    }

    /**
     * Downloads-DOWNLOADTITEL-view63.html
     * RewriteRule ^(Downloads)-.*-view([0-9]+)(-.*)?\.html$ mod.php?$1&________________________op-view-lid-$2$3 [L]
     */
    if ($pid) {
        $inquery = implode(',', array_unique(array_shift($pid)));
        $qry = "SELECT conid, cattitle FROM {$prefix}_pmxContest_contest WHERE conid in ($inquery)";
        $result = sql_query($qry);
        while (list($conid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$conid] = pmxModrewrite::title_entities($title, '-');
        }
        foreach ($pid as $key => $link) {
            /* schreibt alle Parameter um in das normale pragmaMx mod_reweite Format */
            $new_url = pmxModrewrite::title_parameters($link, 'pid');
            /* den neuen URL zusammensetzen */
            $new_url = $name . '-title-' . $titles[$link['pid']] . '-' . $link['pid'] . $new_url;
            /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
            $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
        }
    }

    /**
     */
    if ($pic) {
        $inquery = implode(',', array_unique(array_shift($pic)));
        $qry = "SELECT pid, title FROM {$prefix}_pmxContest_picture WHERE pid in ($inquery)";
        $result = sql_query($qry);
        while (list($lid, $title) = sql_fetch_row($result)) {
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }
        foreach ($pic as $key => $link) {
            $new_url = pmxModrewrite::title_parameters($link, 'pa', 'pid');
            $new_url = $name . '-picture-' . $titles[$link['pid']] . '-' . $link['pid'] . $new_url;
            $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
        }
    }

    if ($rules) {
        $inquery = implode(',', array_unique(array_shift($rules)));
        $qry = "SELECT catid, cattitle FROM {$prefix}_pmxContest_category WHERE catid in ($inquery)";
        $result = sql_query($qry);
        while (list($lid, $title) = sql_fetch_row($result)) {
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }
        foreach ($rules as $key => $link) {
            $new_url = pmxModrewrite::title_parameters($link, 'pa', 'cid');
            $new_url = $name . '-rules-' . $titles[$link['cid']] . '-cat-' . $link['cid'] . $new_url;
            $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
        }
    }
    if ($rules2) {
        $inquery = implode(',', array_unique(array_shift($rules2)));
        $qry = "SELECT conid, cattitle FROM {$prefix}_pmxContest_contest WHERE conid in ($inquery)";
        $result = sql_query($qry);
        while (list($lid, $title) = sql_fetch_row($result)) {
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }
        foreach ($rules2 as $key => $link) {
            $new_url = pmxModrewrite::title_parameters($link, 'pa', 'con');
            $new_url = $name . '-rules-' . $titles[$link['con']] . '-con-' . $link['con'] . $new_url;
            $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
        }
    }
}

?>